From d593a2063a997c86de4b9350b97d4ad6527bddef Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Sun, 1 Mar 2026 18:45:25 +0700
Subject: [PATCH v9 25/26] Fixed 2 small bugs

1. Overwrite of init mode by last mode in checkInitSteps

2. Bledding of init progress from previous mode under new one (eg, '-IggGG')
---
 src/bin/pgbench/pgbench.c | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 7d3a1583152..daf33d73814 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5125,8 +5125,11 @@ showPopulateTableCopyProgress(const char *table, int64 current, int64 total)
 		}
 	}
 
-	if (current == total && chars != 0 && eol != '\n')
-		fprintf(stderr, "%*c\r", chars, ' ');	/* Clear the current line */
+	if (current + 1 == total && chars != 0)
+	{
+		fprintf(stderr, "%*c", chars, ' ');	/* Clear the current line */
+		fputc(eol, stderr);
+	}
 }
 
 static void
@@ -5810,7 +5813,6 @@ checkInitSteps(const char *initialize_steps)
 			case INIT_STEP_GEN_TYPE_INSERT_SERIES:
 			case INIT_STEP_GEN_TYPE_INSERT_UNNEST:
 				data_init_type++;
-				data_generation_type = *step;
 				break;
 		}
 	}
@@ -5859,11 +5861,13 @@ runInitSteps(const char *initialize_steps)
 			case INIT_STEP_GEN_TYPE_COPY_TEXT:
 			case INIT_STEP_GEN_TYPE_COPY_BINARY:
 				op = "client-side generate";
+				data_generation_type = *step;
 				initGenerateDataClientSide(con);
 				break;
 			case INIT_STEP_GEN_TYPE_INSERT_SERIES:
 			case INIT_STEP_GEN_TYPE_INSERT_UNNEST:
 				op = "server-side generate";
+				data_generation_type = *step;
 				initGenerateDataServerSide(con);
 				break;
 			case INIT_STEP_GEN_TYPE_SINGLE_XACT:
-- 
2.43.0

